/*
NAME: ThunderBrowse Tabs
AUTH: GameSpotting! Networks
DESC: Defines ThunderBrowse's tabs system that uses TB3's tabs
*/

var TBrowse3Tabs = {
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbrowse."),
    get selectedTab() 
    {
	   var tabmail = TBrowseGlobal.getTabHandler();
      return tabmail.tabContainer.childNodes[tabmail.tabContainer.selectedIndex];
    },    
    set selectedTab(tab) {
        TBrowseGlobal.getTabHandler().selectedItem = tab;
    },
    addTab: function(url,refer,secret,dataPost,loadinbg) {
       var args = {};
       args["url"] = url;
       args["refer"] = refer;
       args["secret"] = secret;
       args["dataPost"] = dataPost;
       var bgSetting = this.prefs.getBoolPref("tabswitch");
       if(loadinbg && loadinbg == true)
	       args["background"] = !bgSetting;
       else if(loadinbg == null && bgSetting == false)
	       args["background"] = true; 
       var tab = TBrowseGlobal.getTabHandler().openTab("thunderbrowse",args);
       return tab;
    },
    tabContainer: function()
    {
      return TBrowseGlobal.getTabHandler().tabContainer;    
    },
    getBrowserAtIndex: function(i) 
    {
        return TBrowseGlobal.getTabHandler().tabModes.thunderbrowse.tabs[i];
    },
    getBrowserForTab: function(tab) 
    {
       if(tab.browser)
        return tab.browser;
       else
       {
         var tabmail = TBrowseGlobal.getTabHandler();
         if(tabmail.currentTabInfo.mode.type == "thunderbrowse")
           return tabmail.currentTabInfo.browser;
         else
          return document.getElementById("messagepane");
       }  
    },
    removeTab: function(tab, noswitch) 
	 {
      if(TBrowseGlobal.getTabHandler())
       TBrowseGlobal.getTabHandler().closeTab(tab);      
    },
    removeCurrentTab: function()
    {
      this.removeTab(this.selectedTab);    
    }, 
    extBrows: function (url)
    {
      ThunderBrowseHandler.loadInExternalBrowser(url);    
    },
    loadHomePage: function()
    {
		this.addTab(TBrowseDev.getUserHomepage(),null,true);
    },
    openLinkinTab: function() 
    {
      var linkclicked;
      
      if(gContextMenu && gContextMenu.onLink)
        linkclicked = ('getLinkURL' in gContextMenu) ? gContextMenu.getLinkURL() : gContextMenu.linkURL();
      else if(document.popupNode)
      {
        if(document.popupNode.hasAttribute("href"))
          linkclicked = document.popupNode.href;
        else if(document.popupNode.parentNode && document.popupNode.parentNode.hasAttribute("href"))
          linkclicked = document.popupNode.parentNode.href;
      }  
      else
        linkclicked = TBrowseGlobal.getCurrentURL();
        
      if (linkclicked) 
        this.addTab(linkclicked);
    }
};
