/*
NAME: ThunderBrowse Buttons
AUTH: GameSpotting! Networks
DESC: Defines what each button/widget should do in ThunderBrowse
*/
var ThunderBrowseButtons = {
fullScreen: function()
{
	if(!TBrowseGlobal.getTabHandler())
	  var mailbox = $("messengerBox");
	else
	  var mailbox = $("displayDeck");
	var foldersidebar = $("folderPaneBox");
	var fullwindowbutton = $("urlbarmax");
	if(mailbox.collapsed == false && foldersidebar.collapsed == false)
	{
		mailbox.setAttribute("collapsed","true");
		foldersidebar.setAttribute("collapsed","true");
		thunderbrowseprefs.setBoolPref("fullscreen",true);
		gTBNavBar.setAttribute("collapsed","false");
		$("messagepanebox").setAttribute("flex","1");
		var tbstrings = $("tburlstrings");
		var urlwindowcollapse = tbstrings.getString('urlwincollapse');
  		if(fullwindowbutton)
		fullwindowbutton.setAttribute("tooltiptext",urlwindowcollapse);
	}
	else
	{
		var tbstrings = $("tburlstrings");
		var urlwindowexpand = tbstrings.getString('urlwinexpand');
		mailbox.setAttribute("collapsed","false");
		foldersidebar.setAttribute("collapsed","false");
		if(fullwindowbutton)
		fullwindowbutton.setAttribute("tooltiptext",urlwindowexpand);	
	}
},
collapseBar: function()
{
	var urlbarcontrollerbutton = $("urlbarcollapse");
	var isshowing = gTBNavBar.collapsed;
	if(thunderbrowseprefs.getBoolPref("hideme") == false)
	{
		TBrowserCore.toggleContent(false);
		var tbstrings = $("tburlstrings");
		var urlbarexpand = tbstrings.getString('urlbarexpand');
		gTBNavBar.setAttribute("collapsed",true);
		thunderbrowseprefs.setBoolPref("hideme",true);
  		if(urlbarcontrollerbutton)
		urlbarcontrollerbutton.setAttribute("tooltiptext",urlbarexpand);
		$("tbmenubarhider").setAttribute("label",urlbarexpand);
	}
	else
	{
		var tbstrings = $("tburlstrings");
		var urlbarcollapse = tbstrings.getString('urlbarcollapse');
		gTBNavBar.setAttribute("collapsed",false);
		thunderbrowseprefs.setBoolPref("hideme",false);
  		if(urlbarcontrollerbutton)
		urlbarcontrollerbutton.setAttribute("tooltiptext",urlbarcollapse);
		$("tbmenubarhider").setAttribute("label",urlbarcollapse);
	}
},
goButton: function(event)
{
  if(event.button == 1)
  {
   if(window.gTBURLBox.value && (window.gTBURLBox.value != "" || window.gTBURLBox.value != null))
	ThunderTabBrowser.addTab(window.gTBURLBox.value);
  }
  else if(event.button != 2)
	return 0;
},
goBack: function(event,browser){ TBHistory.goBack(event,browser); },
goForward: function(browser){ TBHistory.goForward(browser);},

doRefresh: function()
{
//improve this by reload
checkBrowser();
tbrowser.reload();
}

};
var TBrowseLinkWidgets = {
   RSSHeaderClick : function(event,checkheader)
   {
     	checkBrowser();
    	if(event.button != 2 && checkheader)
    	{
    		event.preventDefault();
    		var RSSurl = currentHeaderData["content-base"];
    		if (RSSurl) 
    		{
    			var linkurl = RSSurl.headerValue;
    			var canLoad = TBrowsePermissions.linksAllowed();
    	    if(event.button == 1)
    			{
    				if(thunderbrowseprefs.getBoolPref("middletabs") == true && canLoad == true)
    					ThunderTabBrowser.addTab(linkurl);
    				else
    					ThunderBrowseHandler.loadInExternalBrowser(linkurl);
    			}
    			else
    			{
    				if(canLoad == true)
    					ThunderBrowseHandler.regularLinkLoad(linkurl);
    				else
    					ThunderBrowseHandler.loadInExternalBrowser(linkurl);
    			}
    		}
    	}   
   },
   RSSHeaderRightClk : function(event,theURLHeader)
   {
     	if(theURLHeader)
    	{
    	  if(theURLHeader.value == "" || theURLHeader.value == null)
    	    var urlFromHeader = theURLHeader.getAttribute("aria-label").replace("website: ","");
    		else
          var urlFromHeader = theURLHeader.value;
    		var canLoad = TBrowsePermissions.linksAllowed();
    		if(event.button == 1)
    		{
    			if(thunderbrowseprefs.getBoolPref("middletabs") == true && canLoad == true)
    				ThunderTabBrowser.addTab(urlFromHeader);
    			else
    				ThunderBrowseHandler.loadInExternalBrowser(urlFromHeader);
    		}
    		else
    		{
    			if(canLoad == true)
    				ThunderBrowseHandler.regularLinkLoad(urlFromHeader);
    			else
    				ThunderBrowseHandler.loadInExternalBrowser(urlFromHeader);
    		}
    	}   
   },
    /* Toggles link loading for the statusbar. */
   toggleLinkLoading : function(event)
   {
    if(event.button == 2)
		  $('tbhelpout').showPopup($('statusbar-thunderbrowse'),-1, -1, "popup", 'bottomleft', 'topleft');
	  else
	  {
  		var tb_statusBar = $("statusbar-thunderbrowse-image");
  		if(thunderbrowseprefs.getBoolPref("loadother") == false)
  		{
  			tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/no-tb.png");
  			thunderbrowseprefs.setBoolPref("loadother",true);  
  		}
  		else
  		{
  		    	tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/yes-tb.png");
  			thunderbrowseprefs.setBoolPref("loadother",false);  
  		}
  	}   
   },
   isRightImage : function()
   {
    var tb_statusBar = $("statusbar-thunderbrowse-image");
	  if(thunderbrowseprefs.getBoolPref("loadother") == false)
		  tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/yes-tb.png");
	  else
		  tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/no-tb.png");   
   }
};
