/*
NAME: ThunderBrowse Uninstaller
AUTH: GameSpotting! Networks
DESC: Uninstalls ThunderBrowse and resets user prefs to what they were originally
*/
const tbrowseguid = "ThunderBrowse@thunderbrowse.com";
var tbrowseuninprefs = Ccl["@mozilla.org/preferences-service;1"].getService(Cil.nsIPrefService);

var ThunderBrowseUninstaller = {
    _uninstall : false,
	_disabled  : false,
    _appManager: false,
    onUninstalling: function(addon) 
    {
      if(addon.id == tbrowseguid)
        ThunderBrowseUninstaller._uninstall = true;
    },
    onDisabling: function(addon)
    {
      if(addon.id == tbrowseguid)
        ThunderBrowseUninstaller._disabled = true;
    },
    onOperationCancelled: function(addon)
    {
      if(addon.id == tbrowseguid)
      {
        ThunderBrowseUninstaller._uninstalled = (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0;
        ThunderBrowseUninstaller._disabled = (addon.pendingOperations & AddonManager.PENDING_DISABLE) != 0;      
      }    
    },
    updateState : function()
    {
    	if(ThunderBrowseUninstaller._uninstall == true || ThunderBrowseUninstaller._disabled == true) 
		{
            var uninstallString = document.getElementById("tburlstrings").getString('tbUninstall');
			var thundercheck = (ThunderBrowseUninstaller._disabled == true) ? false : confirm(uninstallString);
            tbrowseuninprefs.setBoolPref("network.protocol-handler.external-default", true);
            
            if(thundercheck == true)
            {
            var myHP = TBrowseDev.getUserHomepage();            
        var appinfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);      
            if(myHP == "http://start.thunderbrowse.com" && appinfo.ID != "express@postbox-inc.com")
            {
                    var thehomepage = tbrowseuninprefs.getCharPref("tbrowse.backuppage");
                    if(appinfo.ID == "postbox@postbox-inc.com")
                        tbrowseuninprefs.setCharPref("pb.start_page.url",thehomepage);
                    else
                        tbrowseuninprefs.setCharPref("mailnews.start_page.url",thehomepage);
            }
                
                Ccl["@mozilla.org/preferences-service;1"].getService(Cil.nsIPrefBranch).deleteBranch("extensions.tbrowse");
            }
            ThunderBrowseUninstaller.unregister();
		}
    },
	observe : function(subject, topic, data) 
    {
        if (topic == "quit-application-granted") 
            ThunderBrowseUninstaller.updateState();
        else if (topic == "em-action-requested") 
        {
            subject.QueryInterface(Components.interfaces.nsIUpdateItem);
            if (subject.id == tbrowseguid) 
            {
                if (data == "item-uninstalled") 
                   ThunderBrowseUninstaller._uninstall = true;
                else if(data == "item-disabled")
                   ThunderBrowseUninstaller._disabled = true; 
                else if(data == "item-cancel-action") 
                {
                   ThunderBrowseUninstaller._uninstall = false;
                   ThunderBrowseUninstaller._disabled = false;
                }
            }
        }
	},
	register : function() 
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		
        if(ThunderBrowseUninstaller._appManager == false)
            observerService.addObserver(this, "em-action-requested", false);
            
		observerService.addObserver(this, "quit-application-granted", false);
	},
	unregister : function() 
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		
        if(ThunderBrowseUninstaller._appManager == false)
            observerService.removeObserver(this,"em-action-requested");
            
		observerService.removeObserver(this,"quit-application-granted");
	},
    addListener: function()
    {
        try
        {
            Components.utils.import("resource://gre/modules/AddonManager.jsm");
            AddonManager.addAddonListener(ThunderBrowseUninstaller);
            ThunderBrowseUninstaller._appManager = true;
        }
        catch(e) { }
        ThunderBrowseUninstaller.register();
    },
    removeListener: function()
    {
        try
        {
            AddonManager.removeAddonListener(ThunderBrowseUninstaller);
        }
        catch(e) { }
        ThunderBrowseUninstaller.unregister();
    }
};

window.addEventListener("load", ThunderBrowseUninstaller.addListener, false);
window.addEventListener("unload", ThunderBrowseUninstaller.removeListener, false);
